<template>
<div>
  <div
    v-if="!loading">
    <i class="el-icon-loading" style="font-size: 50px; float: left"></i>
  </div>
  <div
    v-if="loading">
    <el-table
      :data="tableData">
      <el-table-column
        prop="email_id"
        label="메일 주소"
        width="180">
      </el-table-column>
      <el-table-column
        prop="name"
        label="이름"
        width="180">
      </el-table-column>
      <el-table-column
        v-for="item in itemInfo"
        :key="item.lecture_item_id"
        :prop="(item.lecture_item_id)+''"
        :label="item.name">
      </el-table-column>
      <el-table-column
        prop="sum"
        label="합계"
        width="180">
      </el-table-column>
      <el-table-column
        prop="average"
        label="평균"
        width="180">
      </el-table-column>
    </el-table>
  </div>
</div>
</template>
<script>
import { mapActions, mapState, mapGetters, mapMutations } from 'vuex';
// import XLSX from 'xlsx';
// import { saveAs } from 'file-saver';
import TableExport from 'tableexport';
import ReportService from '../../services/reportService';

export default {
  name: 'ReportResult',
  props: ['itemIdList'],
  async mounted() {
    const vm = this;
    const res = await ReportService.getClassReport({
      classId: vm.classId,
      lectureItemIdList: vm.itemIdList,
    });
    for (const item of res.data.result) {
      let sum = 0;
      for (const key in item) {
        if (key !== 'name'
          && key !== 'email_id') {
          sum += item[key];
        }
        if (!item[key]) {
          item[key] = '-';
        }
      }
      item.sum = sum;
      item.average = sum !== 0 ? (sum / res.data.itemInfo.length).toFixed(3) : 0;
    }
    vm.tableData = res.data.result;
    vm.itemInfo = res.data.itemInfo;
    vm.loading = true;
  },
  data() {
    return {
      json_fields: {
        'Complete name': 'name',
        Date: 'date',
      },
      tableData: [],
      itemInfo: [],
      loading: false,
    };
  },
  computed: {
    ...mapState('reporting', ['curState', 'curStep', 'studentReportResult', 'lectureTotalReportResult', 'studentTotalReportResult',
      'lectureReportStd', 'studentReportStd']),
    ...mapGetters('NNclass', [
      'currentStudyingClass',
    ]),
    classId() {
      const vm = this;
      return Number.parseInt(vm.$route.params.classId, 10);
    },
  },
  methods: {
    ...mapActions('reporting', ['getLectureList', 'getLectureItemList']),
    ...mapMutations('reporting', ['updateCurStep', 'updateCurState']),
    // onBack() {
    //   const vm = this;
    //   vm.updateCurState({ index: 0 });
    // },
    s2ab(s) {
      const buf = new ArrayBuffer(s.length);
      const view = new Uint8Array(buf);
      for (let i = 0; i < s.length; i += 1) {
        view[i] = s.charCodeAt(i) && 0xFF;
      }
      return buf;
    },
    // 엑셀로 다운로드 기능 190716
    async exportExcel() {
      const vm = this;
      TableExport(document.getElementById('studentResult'), {
        formats: ['xlsx'],
        filename: `class${vm.classId}`,
        sheetname: '학생 통계',
        position: 'bottom',
      });

      /* 엑셀 다운로드 예전 기능
      const ws = XLSX.utils.aoa_to_sheet(ws_data);
      wb.Sheets['학생 통계'] = ws;

      const wbout = XLSX.write(wb, { bookType: 'xlsx', type: 'binary' });
      XLSX.write(wb, { bookType: 'xlsx', bookSST: false, type: 'binary' });
      saveAs(new Blob([vm.s2ab(wbout)], {
        type: 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet'
        // 또는 타입을 octet-stream으로
      }), `class${vm.classId}.xlsx`); */
      /*
      let blob = new Blob([vm.s2ab(wbout)], {
        type: "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet"
        });
      let link = document.createElement('a');
      link.href = window.URL.createObjectURL(blob);
      link.target = '_self';
      link.download = `class${vm.classId}.xlsx`;
      link.click(); */
    },
  },
};

</script>
<style scoped>
 .cth {
  height: 50px;
  width: 100px;
  text-align: center;
  border: 1px solid black;
}
.ctd {
  width: 120px;
  height: 40px;
  text-align: center;
  border: 0.5px solid black;
} 
</style>
